// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008 - INRIA - Sabine Gaüzere
// Copyright (C) 2010-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================
// <-- JVM NOT MANDATORY -->

path = distfun_getpath (  );
exec(fullfile(path,"tests","unit_tests","testingutilities.sce"));


rtol = 1.e-2;
atol = 1.e-1;

// The number of classes in the histogram
// NC must be even.
NC = 2*12;
N=10000;

// Set the seed to always get the same random numbers
distfun_seedset(0);

//
// distfun_rndnbn
//
// This is a piecewise function.

function p = mycdfnbn (X,A,B)
  p = distfun_cdfnbn(X,A*ones(X),B*ones(X),(1-B)*ones(X));
endfunction

A = 7;
B = 0.1;
R = distfun_rndnbn(A,B,400,800);
checkMeanVariance ( 400 , 800 , R , A*(1-B)/B , A*(1-B)/B^2 , rtol );

// Increase the tolerance for this test.
for A = floor(linspace(1,20,4))
for B = linspace(0.1,0.9,4)
    R = distfun_rndnbn(A,B,1,N);
    checkRNGLaw ( R , list(mycdfnbn,A,B) , N , NC , 2*rtol , atol , %f );
end
end

// Check expansion of arguments
a = matrix(1:6,2,3);
b = matrix(linspace(0.1,0.9,6),2,3);
checkRNG2argsOld ( 2 , 3 , distfun_rndnbn , a, b);

