// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008 - INRIA - Sabine Gaüzere
// Copyright (C) 2010-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================
// <-- JVM NOT MANDATORY -->

path = distfun_getpath (  );
exec(fullfile(path,"tests","unit_tests","testingutilities.sce"));


rtol = 1.e-2;
atol = 1.e-1;

// The number of classes in the histogram
// NC must be even.
NC = 2*12;
N=10000;

// Set the seed to always get the same random numbers
distfun_seedset(0);

//
// distfun_rndnf
// http://mathworld.wolfram.com/NoncentralF-Distribution.html
//

function p = mycdfnf (X,A,B,C)
  p = distfun_cdffnc(X,A*ones(X),B*ones(X),C*ones(X));
endfunction

A = 4;
B = 3;
C = 10;
R = distfun_rndnf(A,B,C,400,800);
checkMeanVariance ( 400 , 800 , R , ((C+A)*B)/(A*(B-2)) , [] , 4*rtol );

for A = floor(linspace(1,20,4))
for B = floor(linspace(1,20,4))
for C = floor(linspace(1,20,4))
    R = distfun_rndnf(A,B,C,1,N);
    checkRNGLaw ( R , list(mycdfnf,A,B,C) , N , NC , 2*rtol , atol );
end
end
end

// Check expansion of arguments
a = matrix(1:6,2,3);
b = a+1;
c = b+1;
checkRNG3argsOld ( 2 , 3 , distfun_rndnf , a, b, c);
